<?php

/*

 $Id: autoreg_portal.php 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/docs/modules/autoreg_portal.php $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*!
	@header AutoReg Global Page
	Users are sent to this page if they havn't specified a specific autoreg type to go after
	this page shows _all_ autoreg zones they have access to and their tools...
	
*/

/* Start House Keeping */

	require "../../modules/config.php";

        // do anything that needs to be done here
        if (!check_session()) { logout(); }
	
        // setup the user environment
        setup_user_environment($action, $zone_id);

/* End House Keeping */

$autoreg = new Autoreg($user->username,$user->autoreg_type);

show_template('autoreg_header'); 

// If they havn't accepted the AUP
if (!$agree && !$user->agree) {
	require ($conf['prefix'] . "/templates/show_autoreg_aup.inc");
}
// If they have been disabled!

elseif ($autoreg->disabled) {
	show_template('autoreg_disabled');
}
// They have accepted it.. they are good to go
else {
	$user->agree = $agree;
	$info = $conf['modules']->get_info('autoreg');

	// foreach acl'd 
	foreach($info['acl'] as $autoreg_type => $value) {
		if ($value) {
			if ($autoreg->has_acl_access($user->username,$autoreg_type)) {
				$autoreg->show_autoreg($autoreg_type,$info);
			}
		}
		// If it's not ACL'd then we can let them see it 
		else {
			$autoreg->show_autoreg($autoreg_type,$info);
		}
	} // end foreach 
			

} // end else

show_template('autoreg_footer'); 


?>
