<?php

/*

 $Id: adminoption.php 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/modules/class/adminoption.php $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/
/*!
	@header AdminOption Class
	The option class works from the dhcp_option table and 
	allows us to manage the dhcp_options inside maintain
*/

class AdminOption {
	var $id;
	var $name;
	var $access;
	var $value;
	var $type;
	var $custom;
	var $enabled;

	//another object
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function AdminOption ($option_id=0) {

		$this->id   = $option_id;
		
		if ($this->id) { 
			$info 		= $this->get_info();
			$this->name	= $info->name;
			$this->access	= $info->access;
			$this->value	= $info->value;
			$this->type	= $info->type;
			$this->custom	= $info->custom;
			$this->enabled	= $info->enabled;

		} // if this->id
		
		$this->object_history = new ObjectHistory('admin_option',$this->id);
		
	} // AdminOption

	/*!
		@function get_info
		@discussion nuff said
	*/
	function get_info () {
	
		$sql = "SELECT * FROM dhcp_options WHERE id='$this->id'";
		$db_result = mysql_query($sql, dbh());		

		return mysql_fetch_object($db_result);

	} // get_info


	/*!
		@function check_name
		@discussion checks to see if a name
			is valid or not
	*/
	function check_name($name) {

		/* See if it exists */
		$sql = "SELECT * FROM dhcp_options WHERE name LIKE '$name'";
		$db_results = mysql_query($sql, dbh());

		if (mysql_fetch_object($db_results)) { 
			return false; 
		}

		/* See if it's got something besides A-Z,0-9,. and - */
		if (!preg_match("/^[A-Za-z0-9\.\-]*$/",$name)) {
			return false;
		}

		return true;

	} // check_name

	/*!
		@function check_space
		@discussion checks to see if the space
			name is valid or not
	*/
	function check_space($space) {
		
		/* A-Z 0-9 */
		if (!preg_match("/^[A-Za-z0-9]*$/", $space)) { 
			return false;
		}

		return true;

	} // check_space


	/*!
		@function create
		@discussion creates a new dhcp option
	*/
	function create($name,$option_type,$access,$is_custom,$space,$value) {
		global $user;

		
		// Escape any special chrs
		$value = sql_escape($value);

		/* Create the Bugger */
		$sql = "INSERT INTO dhcp_options (`name`,`type`, `access`, `custom`, `value`, `enabled`, `space`) VALUES " .
			" ('$name', '$option_type', '$access', '$is_custom','$value','1', '$space') ";

		$db_results = mysql_query($sql, dbh()); 
		$object_id = mysql_insert_id(dbh());

		/* Create creation record */
		$date = time();
		$this->object_history->insert($user->username,'admin_option', $object_id,$date,'No Comment');	

	} // create


	/*
		@function delete
		@discussion deletes this record
	*/
	function delete() {
		global $user;

		// Delete it
		$sql = "DELETE FROM dhcp_options WHERE id='$this->id'";
		$db_results = mysql_query($sql, dbh());

		// Track the deletion
		$date = time();
		$this->object_history->insert($user->username, 'delete', $object_id, $date,"Deleted $this->name DHCP option. Space:$this->space Value:$this->value");

	} // delete

} // class AdminOption

?>
