<?php

/*

 $Id: ip.php 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/modules/class/ip.php $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header IP Class
	The ip address object ... functions for manipulating, changing
	and checking diffs here.

*/

class IP {
	var $ip_int;
	var $ip_addr;
	var $subnet;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function IP ( $ip_int = 0 ) {
		global $conf;

		$this->ip_int   = $ip_int;
		$this->ip_addr  = $this->int2ip($this->ip_int);
 
		if ($ip_int) {
			$info = $this->get_info();
			$this->subnet	= new Subnet($info->id);
		} 
	} // Host


	function get_info () {
		global $conf;

		$sql = "SELECT * FROM subnet WHERE subnet <= '$this->ip_int' ORDER BY subnet DESC LIMIT 1";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info


	function int2ip($i) {
		// FIX FOR PHP 4.1
		// http://php.oregonstate.edu/manual/en/function.long2ip.php
		settype($i, "double");

		return long2ip($i);
	} // int2ip

	/**
	*
	* Takes an ip in dotted quad form and converts it to its integer representation
	*
	* @access	public	$ip as an integer
	* @param	$ip		the ip in dotted quad form
	* @deprecated		Please use Net_IPv4::ip2int
	*/
	function ip2int($ip) {
		return Net_IPv4::ip2double($ip);
	} // ip2int

	// we might want to use IP objects that aren't in the database
	//   so the current constructor won't work ... if we use this
	//   function to update the current IP we can create an empty
	//   IP (new IP(0)) and then use update_ip_int to set the needed
	//   variables ... the most obvious case for this would be subnet
	//   masks
	function update_ip_int($ip_int) {
		$this->ip_int  = $ip_int;
		$this->ip_addr = $this->int2ip($ip_int);
	}

	// do the same as above but in reverse for a dotted ip
	function update_ip_dotted($ip) {
		$this->ip_addr = $ip;
		$this->ip_int  = $this->ip2int($ip);
	}

	// check to make sure it's in dotted-quad format 
	function is_dotted_quad($ipaddr) {

		if (preg_match("/^\d+\.\d+\.\d+\.\d+$/", $ipaddr) ) {
			return true;
		}		

		return false;

	} //is_dotted_quad

	/*!
		@function is_free
		@discussion checks to see if a specific IP is free
	*/
	function is_free($ip_int) {

		$sql = "SELECT ip FROM host WHERE ip='$ip_int'";
		$db_results = mysql_query($sql, dbh());

		if (mysql_fetch_object($db_results)) {
			return false;
		}
		
		return true;

	} // is_free

	//Check the IP blocks to make sure said IP Int exists
	function ip_exists($ip_int) {
		global $conf;

		$sql = "SELECT * FROM ip_blocks WHERE start<='$ip_int' AND end>='$ip_int' AND enabled='1'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if ($r = mysql_fetch_object($db_results)) {
			return true;
		}

		return false;

	} //ip_exists

	// Accessor functions -- things only used by this class or for
	//    debugging purposes

	function _show () {
		print ("IP: ip_int -> $this->ip_int, ip_addr -> $this->ip_addr, ");
		print_r(get_object_vars($this->subnet));
		print ("end IP<br>\n");
	}

	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
}

?>
