<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: workgroup.php 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/modules/class/workgroup.php $

 The workgroup class definition that describes workgroup information
   for given hosts.  Each host has a workgroup definition associated with
   it and it allows us to set per-host DHCP options as well as dynamic
   VLAN settings.

*/

class Workgroup {

	var $id;
	var $name;

	// Constructed var
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Workgroup( $workgroup_id = 0) {
		global $conf;

		$this->id = $workgroup_id;
		$info = $this->get_info();

		if ( ! $info ) {
			return false;
		}

		$this->name		= $info->name;

		$this->object_history	= new ObjectHistory('workgroup',$this->id);
	
	} // Workgroup

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM workgroup WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

        /*!
                @function get_options
                @discussion get the local options for this object assumes $this
        */
        function get_options() {
                global $conf;

                $sql = "SELECT * FROM object_option WHERE object_id=$this->id AND type='workgroup'";
                $db_result = mysql_query($sql, $conf['dbh']);

                while ( $obj = mysql_fetch_object($db_result) ) {
                        $options[] = new Option($obj->id, 'workgroup');
                }

                return $options;

        } // get_options

	// get the ranges that this workgroup is allowed to be used in
	function get_ranges() {
                global $conf;

		if (!$this->subnet->id) { return array(); }

                $sql = "SELECT id FROM ranges WHERE subnet=". $this->subnet->id;
                $db_result = mysql_query($sql, $conf['dbh']);

		$ranges = array();
		
		while ($range = mysql_fetch_object($db_result) ) {
			$ranges[] = new Range($range->id);	
		}

		return $ranges;
        } // get_ranges

	/*!
		@function get_zones
		@discussion gets all the zones that are mapped to this workgroup
	*/
	function get_zones() {
		global $conf;

		$sql = "SELECT zone FROM zone_workgroup WHERE zone_workgroup.workgroup='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) { 
			$results[] = new Zone($r->zone);
		}


		return $results;


	} // get_zones

	/*!
		@function has_zone
		@discussion check to make sure this workgroup is allowed in this zone
			based off of $this
	*/
	function has_zone($zone_id) {
		
		$sql = "SELECT * FROM zone_workgroup WHERE workgroup='$this->id' AND zone='$zone_id'";
		$db_results = mysql_query($sql, dbh());

		if (mysql_fetch_row($db_results)) {
			return true;
		}
		else {
			return false;
		}

	} // has_zone

	/*!
		@function has_access
		@discussion checks to make sure a specific user
			has access to this workgroup, (50+ require)
	*/
	function has_access($username) {

		$sql = "SELECT * FROM zone_user,zone_workgroup WHERE zone_workgroup.workgroup='$this->id' AND zone_user.username='$username' AND zone_user.zone=zone_workgroup.zone AND zone_user.level >='50'";
		$db_results = mysql_query($sql, dbh());

		$results = mysql_num_rows($db_results);

		if ($results) { 
			return true;
		}

		return false;

	} // has_access

	/*!
		@function check_name
		@discussion this checks the workgroup name and makes sure we don't have a duplicate
			and that it only uses a-z0-9 & - & .
	*/
	function check_name($name, $workgroup=0) {
		global $conf;

		if (!preg_match("/^[a-zA-Z0-9\-\.\s]+$/", $name)) {
			$conf['error']->add_error('name',"Error Workgroup names may only contain A-Z, 0-9, -, .");
		}
		
		$sql = "SELECT * FROM workgroup WHERE name LIKE '$name'";
		if ($workgroup->id) { 
			$sql .= " AND id!=$workgroup->id";
		}
		
		$db_results = mysql_query($sql, dbh());
		if (mysql_fetch_row($db_results)) {
			$conf['error']->add_error('name',"Error Workgroup name already found");
		}
		

	} // check_name

	/*!
		@function create_workgroup
		@discussion this creates the workgroup and adds an object_history record
			and adds the first zone --> workgroup mapping
	*/
	function create_workgroup($name,$zone_id,$default,$comment) {
		global $conf, $user;

		// Create our workgroup
		$sql = "INSERT INTO workgroup (`name`) VALUES ('$name')";
		$db_results = mysql_query($sql, dbh());
		$workgroup_id = mysql_insert_id(dbh());

		// Now create the workgroup to zone mapping
		$sql = "INSERT INTO zone_workgroup (zone,workgroup,is_default) VALUES ('$zone_id','$workgroup_id','$default')";
		$db_results = mysql_query($sql, dbh());
		
		// Last but not least create the new object_history record
		$workgroup = new Workgroup($workgroup_id);
		$workgroup->object_history->update($user->username,$comment);	

		return $workgroup_id;

	} //create_workgroup


	/*!
		@function delete_zone
		@discussion deletes a zone_workgroup mapping for this workgroup
	*/
	function delete_zone($zone_id) {
		global $conf,$user;

		// Delete the record
		$sql = "DELETE FROM zone_workgroup WHERE zone='$zone_id' AND workgroup='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$zone = new Zone($zone_id);

		// Add deletion record
		$text = "Delete Zone to workgroup mapping " . $this->name . " to " . $zone->name;
		$conf['ui']->add_delete_history($zone_id,$text,$user->username);	

	} // delete_zone

	/*!
		@function delete
		@discussion deletes the workgroup and any options that
			are assoicated to it, as well as adding a deletion record
			depends upon $this
	*/
	function delete() {
		global $conf, $user;

		// Delete the workgroup it's self
		$sql = "DELETE FROM workgroup WHERE id='$this->id'";
		$db_results = mysql_query($sql, dbh());

		// Delete any option assoicated with it
		$sql = "DELETE FROM object_option WHERE type='workgroup' AND object_id='$this->id'";
		$db_results = mysql_query($sql, dbh());

		// Delete any workgroup --> zone records
		$sql = "DELETE FROM zone_workgroup WHERE workgroup='$this->id'";
		$db_results = mysql_query($sql, dbh());

		// Add the deletion record
		$text = "Deleted workgroup" . $this->name;
		$conf['ui']->add_delete_history(0,$text,$user->username);
		

	} //delete

	/*!
		@function add_zone
		@discussion adds a zone_workgroup mapping for this workgroup
	*/
	function add_zone($zone_id,$default) { 
		global $conf;

		// Check to make sure it isn't in there already...
		$sql = "SELECT id FROM zone_workgroup WHERE workgroup='$this->id' AND zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if (mysql_fetch_array($db_results)) { return false; }

		else {
			if (!$default) { $default = false; }
			$sql = "INSERT INTO zone_workgroup (zone,workgroup,is_default) VALUES ('$zone_id','$this->id','$default')";
			$db_results = mysql_query($sql, $conf['dbh']);
		}

		return true;		

	} // add_zone

	/*!
		@function is_default
		@discussion return true if the workgroup is considered a default workgroup 
			for the specified zone
	*/
	function is_default($zone_id) { 
		global $conf;

		$sql = "SELECT is_default FROM zone_workgroup WHERE zone='$zone_id' AND workgroup='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_array($db_results);

		return $results[0];

	} // is_default

	/*!
		@function make_default
		@discussion makes this workgroup default for the specified zone
	*/
	function make_default($zone_id,$default) {
		global $conf;

		$sql = "UPDATE zone_workgroup SET is_default='$default' WHERE workgroup='$this->id' AND zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);


	} // make_default

	// the update functions... there are a bunch of them
        function update_name ($new_name) {
                $this->update_item('name', $new_name);
                $this->name = $new_name;
        } // update_name

        function update_item($type, $new_item) {
                global $conf;

                $sql = "UPDATE workgroup SET $type='$new_item' WHERE id='$this->id'";
                $db_results = mysql_query($sql, $conf['dbh']);
        } // update_item

}

?>
