<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: list_header.inc 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/templates/list_header.inc $

 The default pager widget for moving through a list of many items.

 This relies heavily on the View object to get pieces about how
   to layout this page.

*/

// if for whatever reason we don't have a view here...
if (!$user->view) {
	$user->view->limit = $user->list_view;
} // no view

// do some math here
if ( $user->view->offset >= $user->view->limit ) {
	$offset2 = $user->view->offset - $conf['max_list'];
}
else {
	$offset2 = $user->view->offset;
	if (!$user->view->offset) { $offset2 = "0"; }
}

// since we have an array of hosts, let's build a purdy thingie
if ($total_items/$user->view->limit == intval($total_items/$user->view->limit ))  {
	$pages = $total_items/$user->view->limit;
}
else {
	$pages  = intval($total_items/$user->view->limit) + 1;
}

$offset4 = ($pages - 1);
$offset4 = ($offset4 * $user->view->limit);

//We do this one last to make sure we don't go beyond offset4
$offset3 = $user->view->offset + $user->view->limit;
if ($offset3 >= $offset4) { $offset3 = $offset4; } 


//setup the next action
if ($conf['search_action']) { $next_action = $conf['search_action']; }
else { $next_action = $conf['script'] . "?action=" . $conf['action']; }

?>

<?
// are there enough items to even need this view?
if ( $pages > 1 ) {
?>

<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr bgcolor="<?= $conf['color']->bg['body_dark']; ?>">
    		<td align="left">
			<form name="show_advance_1" method="post" enctype="multipart/form-data" style="Display:inline" action="<?= $conf['web_path'] . "/" . $next_action; ?>">
				<input type="submit" name="foo" value="<<" />
				<input type="hidden" name="sort_type" value="<?= $user->view->sort_type ?>" />
				<input type="hidden" name="sort_offset" value="0" />
			</form>
		</td>
                <td align="left">
			<form name="show_advance_2" method="post" enctype="multipart/form-data" style="Display:inline" action="<?= $conf['web_path'] . "/" . $next_action; ?>">
				<input type="submit" name="foo" value="<" />
				<input type="hidden" name="sort_type" value="<?= $user->view->sort_type ?>" />
				<input type="hidden" name="sort_offset" value="<?= $offset2 ?>" />
			</form>
		</td>
		<td align="center" width="100%">
			<? 
				$counter = 1;
				$sort_offset_pages = 0;

				while ( $counter <= $pages ) {
					if ( $user->view->offset == $sort_offset_pages ) {	
						$link = "<a href=\"" . $conf['web_path'] . "/" . $conf['script'] . "?action" . $conf['action'];
			
						// If we are on a search host we need to add the correct fields
						if ($conf['action'] == 'search_hosts') { 					
							$link .= "&amp;search_field=" .$conf['search']->field . "&search_string=" . $conf['search']->string . "&search_form_type=" .
								 $conf['search']->form_type . "&override_limit=" . $conf['search']->override_limit;
						}
						
						$link .= "&amp;sort_type=" .  $user->view->sort_type . "&sort_offset=" . $sort_offset_pages ."\"><font class=\"error\">$counter</font></a>&nbsp;";
					} // end if it's the page we are looking at
					
					else {
						$link = "<a href=\"" . $conf['web_path'] . "/" . $conf['script'] . "?action=" . $conf['action'];
						// if we are at a search hosts page....	
						if ($conf['action'] == 'search_hosts') {
							$link .= "&amp;search_field=" . $conf['search']->field . "&amp;search_string=" . 
								$conf['search']->string . "&amp;end_range=" . $conf['search']->end_range .
								"&amp;start_range=" . $conf['search']->start_range .  "&amp;search_form_type=" . 
								$conf['search']->form_type . "&override_limit=" . $conf['search']->override_limit;
						} 
						$link .= "&amp;sort_type=". $user->view->sort_type ."&amp;sort_offset=". $sort_offset_pages ."\">$counter</a>&nbsp;";
					} // end else
					
					$sort_offset_pages += $user->view->limit;
					$counter++;
					echo $link . "\n";
				}
			?>
		</td>
                <td align="right">
			<form name="show_advance_3" method="post" enctype="multipart/form-data" style="Display:inline" action="<?= $conf['web_path'] . "/" . $next_action; ?>">
				<input type="submit" name="foo" value=">" />
				<input type="hidden" name="sort_type" value="<? echo $user->view->sort_type ?>" />
				<input type="hidden" name="sort_offset" value="<? echo $offset3 ?>" />
			</form>
		</td>
                <td align="right">
			<form name="show_advance_4" method="post" enctype="multipart/form-data" style="Display:inline" action="<?= $conf['web_path'] . "/" . $next_action; ?>">
				<input type="submit" name="foo" value=">>" />
				<input type="hidden" name="sort_type" value="<? echo $user->view->sort_type ?>" />
				<input type="hidden" name="sort_offset" value="<? echo $offset4 ?>" />
			</form>
		</td>
	</tr>
</table>

<? } // if ?>
