<?php

/*

 $Id: show_create_host.inc 3563 2005-02-02 18:24:37Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/templates/show_create_host.inc $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Create Host Template
	This is the required template for making a new host. 
	This contains both "quick host create" and the full blown one

*/

// we'll need these bad boys below
$domains  = $conf['zone']->domains();
$ranges   = $conf['zone']->ip_ranges();
if ($host_view) { $user->host_view = $host_view; }
?>

<p class="header1">Create a new host in <?= $conf['zone']->name ?></p>

<form name="create_host" method="post" enctype="multipart/form-data" style="Display:inline" action="<?= $conf['web_path']; ?>/create_host.php">

<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
        <tr class="widget-title">
                <td colspan="2">Basic Host Information
                <a href="<?= $conf['web_path']; ?>/create_host.php?host_view=advanced">[Advanced]</a>
                <a href="<?= $conf['web_path']; ?>/create_host.php?host_view=basic">[Basic]</a>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
    		<td title="<? $conf['help']->title('hostname'); ?>"><? $conf['help']->show_link('hostname'); ?> Hostname: </td>
                <td>
                        <input name="name" value="<?= $name; ?>" size="35" />
			<?= $conf['error']->show_error('name'); ?>
                </td>
	</tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title("domain"); ?>"><? $conf['help']->show_link("domain"); ?> Domain: </td>
                <td>
			<? if ($user->is_admin) { ?>
			<input type="radio" onclick="enableField('domain_id');disableField('admin_domain_id');" name="domain_select" value="user" CHECKED />
			<? } ?>
			
			<? $conf['ui']->show_domain_select($domains, $domain_id,'domain_id') ?>
			<?= $conf['error']->show_error('domain'); ?>
                </td>
        </tr>
	<? if ($user->is_admin) { ?>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('domain'); ?>"><? $conf['help']->show_link('domain'); ?>Admin Domains: </td>
		<td><input type="radio" onclick="enableField('admin_domain_id');disableField('domain_id');" name="domain_select" value="admin" />
		<?
			// if they are an admin show them everythi ng
			$admin_domains = $conf['ui']->get_domains("SELECT id FROM domain ORDER BY name ASC");
			$conf['ui']->show_domain_select($admin_domains,$domain_id,'admin_domain_id','disabled');
		?>
		</td>
	</tr>
	<? } ?>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('domain'); ?>"><? $conf['help']->show_link('domain'); ?> Use Default Domain: </td>
		<td>
			<input type="checkbox" onclick="flipField('domain_id');" name="use_default_domain" value="true" />
			<?= $conf['error']->show_error('default_domain'); ?>
		</td>
	</tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('ip_range'); ?>"><? $conf['help']->show_link('ip_range'); ?> IP Address: (select from a range) </td>
		<td>
			<? if ($ranges) { ?>
				<? $conf['ui']->show_ip_ranges_select($ranges, $range_id) ?>&nbsp;&nbsp;&nbsp;
			<? } else { ?>
				<font class="error">No Ranges Found...</font>
			<? } ?>
		        <a href="<?= $conf['web_path']; ?>/range.php?action=display_range_comment" target="_blank">[Comments]</a>
			<?= $conf['error']->show_error('ip_range'); ?>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('ip_range'); ?>"><? $conf['help']->show_link('ip_range'); ?> Specify a IP Address:</td>
		<td>
			<input type="textbox" maxlength="15" size="16" name="specified_ip" value="<?= $specified_ip; ?>" />&nbsp;&nbsp; 
			<?= $conf['error']->show_error('specified_ip'); ?>
		</td>
	</tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('hardware_address'); ?>"><? $conf['help']->show_link('hardware_address'); ?> Hardware Address: </td>
                <td>
                        <input name="ha" value="<?= $ha; ?>" size="18" maxlength="18" />
			<?= $conf['error']->show_error('ha'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('workgroup'); ?>"><? $conf['help']->show_link('workgroup'); ?>Workgroup:</td>
		<td>
		<? 
			$host = new Host(0);
			$workgroups = $host->get_workgroups($conf['zone']->id);
			$conf['ui']->show_select('workgroup_id',$workgroups,'');
		?>
		</td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('mx'); ?>"><? $conf['help']->show_link('mx'); ?>Create Child MX Record to:</td>
		<td>
			<input type="checkbox" name="create_mx" onclick="flipField('mx_dest');flipField('mx_pri');" value="1" />&nbsp;&nbsp;
			<input disabled type="textbox" id="mx_dest" name="mx_dest" value="<?= $mx_dest; ?>" size="35" />&nbsp;&nbsp;
			<select disabled id="mx_pri" name="priority">
				<option value="5" <? if ($mx_pri == 5) { echo "SELECTED"; } ?>>5</option>
				<option value="10" <? if ($mx_pri == 10) { echo "SELECTED"; } ?>>10</option>
				<option value="15" <? if ($mx_pri == 15) { echo "SELECTED"; } ?>>15</option>
			</select>
			<?= $conf['error']->show_error('mx'); ?>
		</td>
	</tr>
</table>
<? show_template('bborder'); ?>

<? if ($user->host_view == "advanced") { ?>
<br /><br /><br />

<? show_template('tborder'); ?>

<table border="0" cellpadding="2" cellspacing="0" width="100%">
        <tr class="widget-title">
                <td colspan="2">Advanced Host Information</td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title("host_expire"); ?>"><? $conf['help']->show_link("host_expire"); ?>Expire In:</td>
		<td>
		<input type="textbox" name="expire" value="<?= $expire; ?>" /> Format (MM/DD/YYYY)
		<?= $conf['error']->show_error('expire'); ?>
		</td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link("host_info_field"); ?> Operating System: </td>
                <td>
                        <input type="radio" name="use_gen_os" value="0" onclick="enableField('os');disableField('generated_os');" />&nbsp;&nbsp;
			<input disabled name="os" id="os" value="<?= $os; ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?>Existing OS Value:</td>
                <td>
                        <input type="radio" name="use_gen_os" value="1" onclick="enableField('generated_os');disableField('os');" CHECKED />&nbsp;&nbsp;
                        <?
                        $host_oss = $conf['zone']->get_host_os();
                        $conf['ui']->show_select('generated_os',$host_oss,$host->os);
                        ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title("host_info_field"); ?>"><? $conf['help']->show_link("host_info_field"); ?> Hardware Type: </td>
                <td>
			<input type = "radio" name="use_gen_type" value="0" onclick="enableField('type');disableField('generated_type');" />&nbsp;&nbsp;     
			<input disabled name="type" id="type" value="<?= $type ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?> Hardware Type: </td>
                <td>
                        <input type = "radio" name="use_gen_type" value="1" onclick="enableField('generated_type');disableField('type');" CHECKED />&nbsp;&nbsp;
                        <?
                        $host_types = $conf['zone']->get_host_hardware_type();
                        $conf['ui']->show_select('generated_type', $host_types,$host->type);
                        ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link("host_info_field"); ?> Location: </td>
                <td>
                        <input name="location" value="<?= $location; ?>" size="35" maxlength="35" />
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link("host_info_field"); ?> Serial Number: </td>
                <td>
                        <input name="serial" value="<?= $serial; ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?> Purchase Date:</td>
                <td>
                <input name="purchase_date" value="<?= $purchase_date; ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?> PO Number:</td>
                <td>
                <input name="po_number" value="<?= $po_number; ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?> Warranty Date:</td>
                <td>
                <input name="warranty_date" value="<?= $warranty_date; ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?> Owning Unit:</td>
                <td>
                <input name="owning_unit" value="<?= $owning_unit; ?>" size="35" maxlength="35" />
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor();?>">
                <td title="<? $conf['help']->title("other_id"); ?>"><? $conf['help']->show_link("other_id"); ?> Other ID: </td>
                <td>
                        <input name="other_id" value="<?= $other_id; ?>" size="35" maxlength="35" />
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('host_info_field'); ?>"><? $conf['help']->show_link('host_info_field'); ?> User ID:</td>
                <td>
                <input name="user_id" value="<?= $user_id; ?>" size="35" maxlength="35" />
                </td>
        </tr>

</table>
<? show_template('bborder'); ?>
<? } //end if host_view == advanced ?>



<? /* CREAT FORM FOR CREATING A HOST ADV AND BASIC */ ?>
<br /><br />
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td>&nbsp;</td>
		<td>
			<input type="submit" name="action" value="Create New Host" />&nbsp;&nbsp;
			<input type="hidden" name="host_view" value="<?= $user->host_view; ?>" />
			<input type="submit" name="action" value="Cancel" />
		</td>
	</tr>
</table>
<? show_template('bborder'); ?>
<input type="hidden" name="not_first_visit" value="1" />

</form>

