<?php

/*

 $Id: show_hosts.inc 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/templates/show_hosts.inc $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Hosts Template
	Show a listing of hosts given an array of host objects.

*/
?>


<? if ($conf['script'] != "search.php") { 
?>
<p class="header2" align="left">Showing Hosts from <?= $hosts[0]->zone->name; ?></p>
<? } ?>

<p>
Hosts in <font class="error">Red</font> are disabled, or blocked. <? $conf['help']->show_link("enabled"); ?><br />
Hosts in <font class="bandwdith_rate">Blue</font> have been rate-limited. <? $conf['help']->show_link("bandwidth_rate"); ?><br />
</p>

<?php
// Display a top widget for creating new hosts
if ($user->has_access($host->zone->id)) {
	$items = array();
	$items[] = "<a href=\"". $conf['web_path'] . "/create_host.php\">Create New Host</a>";
$conf['ui']->display_top_widget($items);
} // if user has access
?>


<?
show_template('tborder');
// total_items has to be passed in to determine how many page tabs to make
$conf['ui']->show_list_header($total_items);
?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr align="center" class="widget-title">
    		<td>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.name" title="<? $conf['help']->title('hostname'); ?>">Hostname</a> 
			<? if ($user->view->sort_type == "host.name") { $conf['ui']->show_arrow(); } ?>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.domain" title="<? $conf['help']->title('domain'); ?>">(Domain)</a>
			<? if ($user->view->sort_type == "host.domain") { $conf['ui']->show_arrow(); } ?>
		</td>
                <td>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.ip" title="<? $conf['help']->title('ip_address'); ?>">IP</a>
			<? if ($user->view->sort_type == "host.ip") { $conf['ui']->show_arrow(); } ?>
		</td>
                <td>
			<? $conf['help']->show_link('last_seen'); ?>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.last_seen" title="<? $conf['help']->title('last_seen'); ?>">Last Seen</a> 
			<? if ($user->view->sort_type == "host.last_seen") { $conf['ui']->show_arrow(); } ?>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.enabled" title="<? $conf['help']->title('enabled'); ?>">(Status)</a>
			<? if ($user->view->sort_type == "host.enabled") { $conf['ui']->show_arrow(); } ?>
		</td>
               <td>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.os" title="<? $conf['help']->title('operating_system'); ?>">OS</a>
			<? if ($user->view->sort_type == "host.os") { $conf['ui']->show_arrow(); } ?>
		</td>
		<td>
			Action
		</td>
	</tr>

<?

$conf['ui']->flip_class(array('odd-row','even-row'),1);
foreach ($hosts as $host) {

	unset($style);

	//Define the class to be used for this row. 
	if (!$host->enabled) { 
		$style="color:" . $conf['color']->text['error'] . ";font-style:italic"; 
	}
	elseif ($host->bandwidth_rate == 'limited') { 
		$class="color:" . $conf['color']->text['link'] . ";font-style:italic";
	}
	elseif ($host->bandwidth_rate == 'blocked') { $style="color:" . $conf['color']->text['error'] . ";font-style:italic"; }
	$class= $conf['ui']->flip_class();

	// Setup the IP display
	if ($host->ip->ip_int) {
		$ip_display = $host->ip->ip_addr;
	}
	else {
		$ip_display = "(Dynamic - " . $host->dynamic_range->start->ip_addr . ")";
	}
?>



	<tr align="center" class="<?= $class; ?>" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td>
		<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=show_host&amp;action_type=read&amp;host_id=<?= $host->id; ?>"><? $conf['ui']->display_field($host->hostname); ?></a>
		</td>
		<td style="<?= $style; ?>"><? $conf['ui']->display_field($ip_display); ?></td>
		<td style="<?= $style; ?>"><? $conf['ui']->display_field($host->show_last_seen()); ?></td>
		<td style="<?= $style; ?>"><? $conf['ui']->display_field($host->os); ?></td>
		<td style="<?= $style; ?>">
			<? if ($user->has_access($host->zone->id) ) { ?>
			<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=show_host&amp;host_id=<?= $host->id ?>">Edit</a> |
				<? if (!$host->enabled) { ?>
					<? if ($conf['script'] == "search.php") { ?>
						<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=enable_host&amp;search=1&amp;host_id=<?= $host->id; ?>">Enable</a> |
					<? } else { ?>
						<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=enable_host&amp;host_id=<?= $host->id ?>">Enable</a> |
					<? } ?>
				<? } else { ?>
					<? if ($conf['script'] == "search.php") { ?>
						<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=disable_host&amp;search=1&amp;host_id=<?= $host->id; ?>">Disable</a> |
					<? } else { ?>
					<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=disable_host&amp;host_id=<?= $host->id ?>">Disable</a> |
					<? } ?>
				<? } // if ?>
			<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=Delete&amp;host_id=<?= $host->id ?>">Delete</a>
			<? } else { ?>
			<a style="<?= $style; ?>" href="<?= $conf['web_path']; ?>/host.php?action=show_host&amp;action_type=read&amp;host_id=<?= $host->id ?>">View</a>
			<? } ?>	
		</td>
	</tr>

<?
}
?>
	
</table>
<? 
	$conf['ui']->show_list_header($total_items);
	show_template('bborder');
?>
