<?php
/*

 $Id: show_migrate_zone_cnames.inc 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/templates/show_migrate_zone_cnames.inc $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*!
	@header Show Migrate Zone Cnames
	Part of the Domain Module
	This page shows all hosts and mx records, and allows you to pick any number 
	of them to have cnames created.... This also serves as the confirmation page.
*/

if (!$info) { $info = $conf['modules']->get_info("domain"); }

?>
<p class="header1">Migrating <?= $conf['zone']->name; ?>'s Records</p>

<p>Please choose put a check by any Hosts, MX records or Cnames you would like a <?= $info['source']; ?> CNAME made for. Once you have selected the CNAMES you would like created click "Migrate Records" to make the changes, there will be no more confirmation messages</p>

<p class="fatalerror" align="center">Changing the Domain Name can cause services, such as printing and e-mail, to not function properly.</p>
<form name="migrate_zone_cname" method="post" action="<?= $conf['web_path']; ?>/modules/domain.php" enctype="Multipart/form-data" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<? if ($mxs) { ?>
<tr class="widget-title" align="left">
	<td colspan="2">Create CNAME's for MX records</td>
</tr>
<? foreach ($mxs as $data) { ?>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td><input type="checkbox" name="mxs[]" value="<?= $data->id; ?>"></td>
		<td>MX Record: <?= $data->hostname; ?> ( <?= $data->server; ?> )</td>
	</tr>
<? } } ?>
<? if ($hosts) { ?>
<tr class="widget-title" align="left">
	<td colspan="2">Create CNAME's for HOST records</td>
</tr>
<? foreach ($hosts as $data) { 
	if ($data->ip->ip_addr) { $ip_addr = $data->ip->ip_addr; }
	else { $ip_addr = "Dynamic"; }
?>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td><input type="checkbox" name="hosts[]" value="<?= $data->id; ?>"></td>
		<td>Host Records: <?= $data->hostname; ?> ( <?= $ip_addr; ?> )</td>
	</tr>
<? } } ?>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>&nbsp;</td>
	<td>
		<input type="hidden" name="action" value="migrate_zone" />
		<input type="hidden" name="domain_id" value="<?= $domain_id; ?>" />
		<input type="hidden" name="create_cnames" value="true" />
		<input type="submit" value="Migrate Records" />&nbsp;&nbsp;&nbsp;
		<input type="submit" name="action" value="Cancel" />
	</td>
</tr>	
</table>
<? show_template('bborder'); ?>
</form>
